http://bugs.gentoo.org/328363
http://repos.archlinux.org/wsvn/community/mailx-heirloom/trunk/mailx-heirloom-openssl-1.0.patch

--- openssl.c
+++ openssl.c
@@ -105,7 +105,7 @@
 static void ssl_load_verifications(struct sock *sp);
 static void ssl_certificate(struct sock *sp, const char *uhp);
 static enum okay ssl_check_host(const char *server, struct sock *sp);
-static int smime_verify(struct message *m, int n, STACK *chain,
+static int smime_verify(struct message *m, int n, STACK_OF(X509) *chain,
 		X509_STORE *store);
 static EVP_CIPHER *smime_cipher(const char *name);
 static int ssl_password_cb(char *buf, int size, int rwflag, void *userdata);
@@ -308,7 +308,7 @@
 	X509 *cert;
 	X509_NAME *subj;
 	char data[256];
-	/*GENERAL_NAMES*/STACK	*gens;
+	/*GENERAL_NAMES*/STACK_OF(GENERAL_NAMES)	*gens;
 	GENERAL_NAME	*gen;
 	int	i;
 
@@ -496,7 +496,7 @@
 }
 
 static int
-smime_verify(struct message *m, int n, STACK *chain, X509_STORE *store)
+smime_verify(struct message *m, int n, STACK_OF(X509) *chain, X509_STORE *store)
 {
 	struct message	*x;
 	char	*cp, *sender, *to, *cc, *cnttype;
@@ -505,7 +505,8 @@
 	off_t	size;
 	BIO	*fb, *pb;
 	PKCS7	*pkcs7;
-	STACK	*certs, *gens;
+	STACK_OF(X509)	*certs;
+	STACK_OF(GENERAL_NAMES) *gens;
 	X509	*cert;
 	X509_NAME	*subj;
 	char	data[LINESIZE];
@@ -614,7 +615,7 @@
 {
 	int	*msgvec = vp, *ip;
 	int	ec = 0;
-	STACK	*chain = NULL;
+	STACK_OF(X509)	*chain = NULL;
 	X509_STORE	*store;
 	char	*ca_dir, *ca_file;
 
@@ -687,7 +688,7 @@
 	X509	*cert;
 	PKCS7	*pkcs7;
 	BIO	*bb, *yb;
-	STACK	*certs;
+	STACK_OF(X509)	*certs;
 	EVP_CIPHER	*cipher;
 
 	certfile = expand((char *)certfile);
@@ -950,9 +951,9 @@
 	off_t	size;
 	BIO	*fb, *pb;
 	PKCS7	*pkcs7;
-	STACK	*certs;
+	STACK_OF(X509)	*certs;
 	X509	*cert;
-	STACK	*chain = NULL;
+	STACK_OF(X509)	*chain = NULL;
 	enum okay	ok = OKAY;
 
 	message_number = n;
